Subject: bug#38317: Buffer-local variables don't work as history for read-from-minibuffer

From: Michael Heerdegen <[email-masked]>
Date: Fri, 22 Nov 2019 16:23:49 +0100

Lars Ingebrigtsen <[email-masked]> writes:

> Looking at the code in read_minibuf, it does seem to access the
> buffer-local value of the HIST variable, but my guess is that the buffer
> it's looking at is the minibuffer?  And the variable isn't buffer-local
> there.

The problem is M-p: this command is called with the minibuffer current.
The helper `goto-history-element' calls (symbol-value
minibuffer-history-variable) and that returns the binding of the
variable in the minibuffer.  Adding to the buffer local history already
works as expected OTOH, so the behavior is inconsistent.

Dunno if there are more inconsistencies to expect when trying to fix
M-p.  My personal point of view is that when we can make it work without
risking breakage of anything else it would be nice to fix this.

Michael.